<?php

namespace Drupal\kiyoh_rating\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Drupal\Core\Block\BlockPluginInterface;
use Drupal\Core\Form\FormStateInterface;

/**
 * Class KiyohRatingBlock.
 *
 * @Block(
 *   id = "kiyoh_rating_block",
 *   admin_label = @Translation("Kiyoh rating"),
 *   category = @Translation("Kiyoh rating")
 * )
 */
class KiyohRatingBlock extends BlockBase implements BlockPluginInterface {

  /**
   * {@inheritdoc}
   */
  public function build() {
    $config = $this->getConfiguration();

    return [
      '#theme' => 'kiyoh_rating_big',
      '#kiyoh_hash' => $config['kiyoh_hash'],
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function blockForm($form, FormStateInterface $form_state) {
    $form = parent::blockForm($form, $form_state);
    $config = $this->getConfiguration();

    $form['kiyoh_hash'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Kiyoh hash'),
      '#description' => $this->t('Fill in your kiyoh hash from the XML API'),
      '#default_value' => $config['kiyoh_hash'] ?? '',
      '#size' => 16,
      '#maxlength' => 16,
      '#required' => TRUE,
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function blockSubmit($form, FormStateInterface $form_state) {
    $this->configuration['kiyoh_hash'] = $form_state->getValue('kiyoh_hash');
    parent::blockSubmit($form, $form_state);
  }

}
